// Next.js API route support: https://nextjs.org/docs/api-routes/introduction
import type {NextApiRequest, NextApiResponse} from "next";
import {app} from "@/firebase";
import {getFirestore, collection, getDocs, setDoc, doc, query, where} from "firebase/firestore";
import {withIronSessionApiRoute} from "iron-session/next";
import {sessionOptions} from "@/lib/session";
import {Group} from "@/interfaces/user";
import {v4} from "uuid";

const db = getFirestore(app);

export default withIronSessionApiRoute(handler, sessionOptions);

async function handler(req: NextApiRequest, res: NextApiResponse) {
	if (!req.session.user) {
		res.status(401).json({ok: false});
		return;
	}

	if (req.method === "GET") await get(req, res);
	if (req.method === "POST") await post(req, res);
}

async function get(req: NextApiRequest, res: NextApiResponse) {
	const {admin, participant} = req.query as {admin: string; participant: string};

	const queryConstraints = [
		...(admin ? [where("admin", "==", admin)] : []),
		...(participant ? [where("participants", "array-contains", participant)] : []),
	];
	const snapshot = await getDocs(queryConstraints.length > 0 ? query(collection(db, "groups"), ...queryConstraints) : collection(db, "groups"));
	const groups = snapshot.docs.map((doc) => ({
		id: doc.id,
		...doc.data(),
	})) as Group[];

	res.status(200).json(groups);
}

async function post(req: NextApiRequest, res: NextApiResponse) {
	const body = req.body as Group;

	await setDoc(doc(db, "groups", v4()), {name: body.name, admin: body.admin, participants: body.participants});
	res.status(200).json({ok: true});
}
